Magic Lantern
Magic Lantern (ML) is a software enhancement that offers increased functionality to the excellent Canon DSLR cameras.

It's an open framework, licensed under GPL, for developing extensions to the official firmware.

Magic Lantern is not a hack, or a modified firmware, it is an independent program that runs alongside Canon's own software. Each time you start your camera, Magic Lantern is loaded from your memory card. Our only modification was to enable the ability to run software from the memory card.

ML is being developed by photo and video enthusiasts, adding functionality such as: HDR images and video, timelapse, motion detection, focus assist tools, manual audio controls much more.

For more details on Magic Lantern please see http://www.magiclantern.fm/